library(UpSetR)

# values correspond to features transferred between nipponbare the rice pangenome graph by grannot, graphaligner, vg annotate and vg inject
# values come from the notebook "compare_graph_transfers.ipynb"

# Datasets

# two transfers are considered equal if they placed a feature at the exact same position
input_0 <- c(
  GraphAligner = 17870,
  "GrAnnoT&VG_annotate&VG_inject" = 17873,
  "GrAnnoT&GraphAligner&VG_annotate&VG_inject" = 37928
)

# two transfers are considered equal if they placed a feature at a maximum distance of 1 bp
input_1 <- c(
  GraphAligner = 2197,
  "GrAnnoT&VG_annotate&VG_inject" = 2200,
  "GrAnnoT&GraphAligner&VG_annotate&VG_inject" = 53601
)

# two transfers are considered equal if they placed a feature at a maximum distance of 10 bp
input_10 <- c(
  GraphAligner = 1769,
  "GrAnnoT&VG_annotate&VG_inject" = 1772,
  "GrAnnoT&GraphAligner&VG_annotate&VG_inject" = 54029
)

# Plot
dataset=input_0
upset(fromExpression(dataset),
      nintersects = length(dataset),
      nsets = 4,
      order.by = "freq",
      decreasing = T,
      mb.ratio = c(0.7, 0.3),
      number.angles = 0,
      point.size = 4,
      text.scale = c(1.5, 1.3, 1.2, 1, 1.5, 1.2)
)