library(ggplot2)
library(dplyr)
library(chron)
library(lubridate)

name_grannot=rep('GrAnnoT',12)
name_liftoff=rep('Liftoff',12)
name_liftoff_db=rep('Liftoff_db',12)
Tool=c(name_grannot,name_liftoff,name_liftoff_db)

Transfer=rep(1:12,3)

time_grannot_temp<-c("00:08:11.64", "00:11:36", "00:15:04.47", "00:19:29.69","00:22:59.03","00:26:13.64","00:29:41.71","00:33:23.48","00:37:06.03","00:39:54.23","00:43:50.98","00:46:45.57")
time_grannot=as_datetime(hms(time_grannot_temp)) # convert in POSIXt

time_liftoff_temp=c("00:23:45.40","00:25:17.86","00:31:30.36","00:34:28.87","00:30:26.11","00:30:55.35","00:32:42.38","00:29:56.66","00:24:28.23","00:23:20.48","00:31:05.91","00:29:36.71")
time_liftoff_t <- cumsum(chron(times=time_liftoff_temp)) # use package chron to apply cumulated sum on the values
time_liftoff=as_datetime(hms(time_liftoff_t)) # convert in POSIXt

time_liftoff_db_temp=c("00:22:07.70","00:23:59.02","00:30:11.18","00:32:58.67","00:28:59.46","00:29:20.64","00:31:01.47","00:28:32.43","00:23:05.29","00:21:53.58","00:29:28.42","00:28:15.11")
time_liftoff_db_t <- cumsum(chron(times=time_liftoff_db_temp)) # use package chron to apply cumulated sum on the values
time_liftoff_db=as_datetime(hms(time_liftoff_db_t)) # convert in POSIXt

Time=c(time_grannot,time_liftoff,time_liftoff_db)


df=data.frame(Transfer,Tool,Time)

df %>%
  ggplot( aes(x=Transfer, y=Time, group=Tool, color=Tool)) +
  theme_light() +
  geom_line() +
  scale_y_datetime(breaks = "hour", date_labels =  "%H:%M:%S") +
  scale_x_continuous(breaks=c(1:12))
