import sys

if not(len(sys.argv)==3) :
        print("expected input : gff files of the two transfer programms : Liftoff and GrAnnot")
        sys.exit(1)
elif (sys.argv[1]=="-h") :
    print("expected input : gff files of the two transfer programms : Liftoff and GrAnnot")
    sys.exit(1)

liftoff_file=sys.argv[1]
grannot_file=sys.argv[2]



# build a dictionnary with the Liftoff alignements

liftoff = open(liftoff_file,'r')
lines=liftoff.readlines()
liftoff.close()

liftoff_aln={}
for line in lines:
    if (len(line.split())==9) & (line.split()[0][0:3]=='Chr'):
        line=line.split()
        feature=line[8].split(';')[0].split('=')[1]
        chr=line[0]
        start=int(line[3])
        stop=int(line[4])
        cov=float(line[8].split(';')[3].split('=')[1])
        seq_id=float(line[8].split(';')[4].split('=')[1])
        pos=list([chr,start,stop,cov,seq_id])
        liftoff_aln[feature]=pos

print(len(liftoff_aln), "features transfered with Liftoff")


# build a dictionnary with the GrAnnot coordinates conversions

grannot = open(grannot_file,'r')
lines=grannot.readlines()
grannot.close()

coord_conv={}
for line in lines:
    if (len(line.split())==9) & (line.split()[0][0:3]=='Chr'):
        line=line.split()
        feature=line[8].split(';')[0].split('=')[1]
        chr=line[0]
        start=int(line[3])
        stop=int(line[4])
        size_diff=int(line[8].split(';')[3].split('=')[1])
        nb_var=int(line[8].split(';')[4].split('=')[1])
        pos=list([chr,start,stop,size_diff,nb_var])
        coord_conv[feature]=pos

print(len(coord_conv),"features transfered with GrAnnot\n")


# intersection between the two transfers :
common=list();only_liftoff=list();only_grannot=list()
for feat_aln in liftoff_aln:
    if feat_aln in coord_conv:
        if feat_aln not in common:
            common.append(feat_aln)
    else:
        only_liftoff.append(feat_aln)

for feat_conv in coord_conv:
    if feat_conv in liftoff_aln:
        if feat_conv not in common:
            common.append(feat_conv)
    else:
        only_grannot.append(feat_conv)

print(len(common),"features were transfered by both programs")
print(len(only_liftoff),"features were transfered only by Liftoff")
print(len(only_grannot),"features were transfered only by GrAnnot\n")

# common transfers
[diff_chr,same_pos,diff_pos,close,close_ish,not_close]=[0,0,0,0,0,0]
list_diff_pos=list()
for feat in common:
    if liftoff_aln[feat][0]==coord_conv[feat][0]: # check if same chromosome 
        if (liftoff_aln[feat][1]==coord_conv[feat][1]) & (liftoff_aln[feat][2]==coord_conv[feat][2]): # exact same position
            same_pos+=1
        else: 
            diff_pos+=1
            if (abs(liftoff_aln[feat][1]-coord_conv[feat][1])<10) & (abs(liftoff_aln[feat][2]-coord_conv[feat][2])<10): # start and stop close
                close+=1
            elif (abs(liftoff_aln[feat][1]-coord_conv[feat][1])<50) & (abs(liftoff_aln[feat][2]-coord_conv[feat][2])<50): # start and stop not to far
                close_ish+=1
            else:
                not_close+=1

    else:
        diff_chr+=1

print(same_pos,"features are at the exact same position between the two transfers")
print(diff_pos,"features are not in the exact same position between the two transfers. among those :")
print(close,"have their start and stop positions less than 10 bases away")
print(close_ish,"have their start and stop positions between 11 and 50 bases away")
print(not_close,"have their start and stop positions more that 50 bases away\n\n")


# average sequence_identity and coverage for liftoff's transfers

coverage=list();sequence_id=list()
for feat in common:
    coverage.append(liftoff_aln[feat][3])
    sequence_id.append(liftoff_aln[feat][4])
print("For the transfers made with Liftoff common with GrAnnot :")
print("the average coverage of the features is",sum(coverage)/len(coverage))
print("the average sequence identity of the features is",sum(sequence_id)/len(sequence_id))

coverage=list();sequence_id=list()
for feat in only_liftoff:
    coverage.append(liftoff_aln[feat][3])
    sequence_id.append(liftoff_aln[feat][4])
print("\nFor the transfers made with Liftoff not found with GrAnnot :")
print("the average coverage of the features is",sum(coverage)/len(coverage))
print("the average sequence identity of the features is",sum(sequence_id)/len(sequence_id))


# average size difference and variation number for grannot's transfers
coverage=list();sequence_id=list()
for feat in common:
    coverage.append(coord_conv[feat][3])
    sequence_id.append(coord_conv[feat][4])
print("\n\nFor the transfers made with GrAnnot common with Liftoff :")
print("the average size difference of the features is",sum(coverage)/len(coverage))
print("the average number of variants of the features is",sum(sequence_id)/len(sequence_id))

coverage=list()
sequence_id=list()
for feat in only_grannot:
    coverage.append(coord_conv[feat][3])
    sequence_id.append(coord_conv[feat][4])
print("\nFor the transfers made with GrAnnot not found with Liftoff :")
print("the average size difference of the features is",sum(coverage)/len(coverage))
print("the average number of variants of the features is",sum(sequence_id)/len(sequence_id))

