import sys

if not(len(sys.argv)==4) :
        print("expected input : gaf file of the gene alignment on the graph, bed file of the intersect between the genes and the segments, gfa file of the graph")
        sys.exit(1)
elif (sys.argv[1]=="-h") :
    print("expected input : gaf file of the gene alignment on the graph, bed file of the intersect between the genes and the segments, gfa file of the graph")
    sys.exit(1)

[gaf_file,bed_file,gfa_file]=[sys.argv[1],sys.argv[2],sys.argv[3]]


def check_alignment(gaf_file,bed_file,gfa_file):
    # dictionnary with the length of the segments.
    gfa=open(gfa_file,"r");gfa_lines=gfa.readlines();gfa.close()
    seg_len={}
    for line in gfa_lines:
        line=line.split()
        if line[0]=="S":
            segment_id='s'+line[1]
            segment_length=len(line[2])
            seg_len[segment_id]=segment_length

    # create a dictionnary that for each feature gives the list of the segments it's on
    gaf=open(gaf_file,'r');gaf_lines=gaf.readlines();gaf.close()
    segments_on_feature={}
    for line in gaf_lines:
        feature_id=line.split()[0].split(";")[0].split('=')[1]
        seg=line.split()[5] # get segments field and split it
        segments=seg.replace('<','>').split('>')
        # for each segment, append the dictionnary
        for segment_id in segments[1:]:
            segment='s'+segment_id
            if feature_id in segments_on_feature.keys():
                segments_on_feature[feature_id].append(segment)
            else:
                list_seg=list()
                list_seg.append(segment)
                segments_on_feature[feature_id]=list_seg



    intersect=open(bed_file,'r');intersects=intersect.readlines();intersect.close()
    [ok,not_ok,no,len_total,len_ok,nb_size,size]=[0,0,0,list(),list(),0,1]

    # compare the alignment with the result from bedtools intersect
    # for each intersection (overlap) between a segment and a feature, check if the aligner found the intersect (ie if the segment is in the list of the feature in the dictionnary)
    for overlap in intersects:
        seg=overlap.split()[3][1:]
        feature_id=overlap.split()[12].split(';')[0].split('=')[1]

        if feature_id not in segments_on_feature.keys(): # feature not found
            no+=1
        else:
            if seg not in segments_on_feature[feature_id]: # feature found but segment not found
                not_ok+=1
                len_total.append(seg_len[seg])
                if seg_len[seg]<=size:
                    nb_size+=1
            else:
                ok+=1 # feature and segment found
                len_ok.append(seg_len[seg])


    print("Alignment file treated : ", gaf_file)
    print(ok,"parts of features were correctly aligned")
    print(not_ok,"parts of features were not correctly aligned")
    print(no,"parts of features were not aligned anywhere")
    print("For the segments misaligned, the average length is:",sum(len_total)/len(len_total),"and",nb_size,"are of length <=",size)
    print("The average size of segments well aligned is",sum(len_ok)/len(len_ok))

liste1=check_alignment(gaf_file,bed_file,gfa_file)

